import type {OmitNever} from '../../types/OmitNever.ts'
import type {WsApiConnection} from './WsApiConnection.ts'
import type {WsApiAction, WsApiRequest, WsApiResponse} from './common/index.ts'

export type WsApiRequestHandler<
  Action extends WsApiAction,
  Request extends WsApiRequest<Action>,
  Response extends WsApiResponse,
> = (
  request: Request & {action: Action},
  responseActions: OmitNever<{
    connection: WsApiConnection
    sendResponse: [Response] extends [never] ? never : (response: Response) => Promise<void>
    closeConnection: () => Promise<void>
  }>,
) => Promise<void>
